diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/multi-model-spectrum-channel.cc ns-3.40/src/spectrum/model/multi-model-spectrum-channel.cc
--- ns-3.39/src/spectrum/model/multi-model-spectrum-channel.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/multi-model-spectrum-channel.cc	2023-09-27 13:30:37.874839800 -0700
@@ -19,6 +19,11 @@
 
 #include "multi-model-spectrum-channel.h"
 
+#include "spectrum-converter.h"
+#include "spectrum-phy.h"
+#include "spectrum-propagation-loss-model.h"
+#include "spectrum-transmit-filter.h"
+
 #include <ns3/angles.h>
 #include <ns3/antenna-model.h>
 #include <ns3/double.h>
@@ -32,10 +37,6 @@
 #include <ns3/propagation-delay-model.h>
 #include <ns3/propagation-loss-model.h>
 #include <ns3/simulator.h>
-#include <ns3/spectrum-converter.h>
-#include <ns3/spectrum-phy.h>
-#include <ns3/spectrum-propagation-loss-model.h>
-#include <ns3/spectrum-transmit-filter.h>
 
 #include <algorithm>
 #include <iostream>
@@ -57,10 +58,9 @@
 std::ostream&
 operator<<(std::ostream& lhs, TxSpectrumModelInfoMap_t& rhs)
 {
-    for (TxSpectrumModelInfoMap_t::iterator it = rhs.begin(); it != rhs.end(); ++it)
+    for (auto it = rhs.begin(); it != rhs.end(); ++it)
     {
-        SpectrumConverterMap_t::iterator jt;
-        for (jt = it->second.m_spectrumConverterMap.begin();
+        for (auto jt = it->second.m_spectrumConverterMap.begin();
              jt != it->second.m_spectrumConverterMap.end();
              ++jt)
         {
@@ -116,7 +116,7 @@
     // we need to scan for all rxSpectrumModel values since we don't
     // know which spectrum model the phy had when it was previously added
     // (it's probably different than the current one)
-    for (RxSpectrumModelInfoMap_t::iterator rxInfoIterator = m_rxSpectrumModelInfoMap.begin();
+    for (auto rxInfoIterator = m_rxSpectrumModelInfoMap.begin();
          rxInfoIterator != m_rxSpectrumModelInfoMap.end();
          ++rxInfoIterator)
     {
@@ -159,7 +159,7 @@
     if (inserted)
     {
         // create the necessary converters for all the TX spectrum models that we know of
-        for (TxSpectrumModelInfoMap_t::iterator txInfoIterator = m_txSpectrumModelInfoMap.begin();
+        for (auto txInfoIterator = m_txSpectrumModelInfoMap.begin();
              txInfoIterator != m_txSpectrumModelInfoMap.end();
              ++txInfoIterator)
         {
@@ -172,8 +172,7 @@
                 NS_LOG_LOGIC("Creating converter between SpectrumModelUid "
                              << txSpectrumModel->GetUid() << " and " << rxSpectrumModelUid);
                 SpectrumConverter converter(txSpectrumModel, rxSpectrumModel);
-                std::pair<SpectrumConverterMap_t::iterator, bool> ret2;
-                ret2 = txInfoIterator->second.m_spectrumConverterMap.insert(
+                auto ret2 = txInfoIterator->second.m_spectrumConverterMap.insert(
                     std::make_pair(rxSpectrumModelUid, converter));
                 NS_ASSERT(ret2.second);
             }
@@ -187,22 +186,19 @@
 {
     NS_LOG_FUNCTION(this << txSpectrumModel);
     SpectrumModelUid_t txSpectrumModelUid = txSpectrumModel->GetUid();
-    TxSpectrumModelInfoMap_t::iterator txInfoIterator =
-        m_txSpectrumModelInfoMap.find(txSpectrumModelUid);
+    auto txInfoIterator = m_txSpectrumModelInfoMap.find(txSpectrumModelUid);
 
     if (txInfoIterator == m_txSpectrumModelInfoMap.end())
     {
         // first time we see this TX SpectrumModel
         // we add it to the list
-        std::pair<TxSpectrumModelInfoMap_t::iterator, bool> ret;
-        ret = m_txSpectrumModelInfoMap.insert(
+        auto ret = m_txSpectrumModelInfoMap.insert(
             std::make_pair(txSpectrumModelUid, TxSpectrumModelInfo(txSpectrumModel)));
         NS_ASSERT(ret.second);
         txInfoIterator = ret.first;
 
         // and we create the converters for all the RX SpectrumModels that we know of
-        for (RxSpectrumModelInfoMap_t::const_iterator rxInfoIterator =
-                 m_rxSpectrumModelInfoMap.begin();
+        for (auto rxInfoIterator = m_rxSpectrumModelInfoMap.begin();
              rxInfoIterator != m_rxSpectrumModelInfoMap.end();
              ++rxInfoIterator)
         {
@@ -216,8 +212,7 @@
                              << txSpectrumModelUid << " and " << rxSpectrumModelUid);
 
                 SpectrumConverter converter(txSpectrumModel, rxSpectrumModel);
-                std::pair<SpectrumConverterMap_t::iterator, bool> ret2;
-                ret2 = txInfoIterator->second.m_spectrumConverterMap.insert(
+                auto ret2 = txInfoIterator->second.m_spectrumConverterMap.insert(
                     std::make_pair(rxSpectrumModelUid, converter));
                 NS_ASSERT(ret2.second);
             }
@@ -247,7 +242,7 @@
     NS_LOG_LOGIC("txSpectrumModelUid " << txSpectrumModelUid);
 
     //
-    TxSpectrumModelInfoMap_t::const_iterator txInfoIteratorerator =
+    auto txInfoIteratorerator =
         FindAndEventuallyAddTxSpectrumModel(txParams->psd->GetSpectrumModel());
     NS_ASSERT(txInfoIteratorerator != m_txSpectrumModelInfoMap.end());
 
@@ -257,7 +252,7 @@
     NS_LOG_LOGIC("converter map first element: "
                  << txInfoIteratorerator->second.m_spectrumConverterMap.begin()->first);
 
-    for (RxSpectrumModelInfoMap_t::const_iterator rxInfoIterator = m_rxSpectrumModelInfoMap.begin();
+    for (auto rxInfoIterator = m_rxSpectrumModelInfoMap.begin();
          rxInfoIterator != m_rxSpectrumModelInfoMap.end();
          ++rxInfoIterator)
     {
@@ -274,7 +269,7 @@
         {
             NS_LOG_LOGIC("converting txPowerSpectrum SpectrumModelUids "
                          << txSpectrumModelUid << " --> " << rxSpectrumModelUid);
-            SpectrumConverterMap_t::const_iterator rxConverterIterator =
+            auto rxConverterIterator =
                 txInfoIteratorerator->second.m_spectrumConverterMap.find(rxSpectrumModelUid);
             if (rxConverterIterator == txInfoIteratorerator->second.m_spectrumConverterMap.end())
             {
@@ -451,7 +446,7 @@
     // On the other hand, having slow SpectrumModel conversion would be
     // less acceptable.
     std::size_t j = 0;
-    for (RxSpectrumModelInfoMap_t::const_iterator rxInfoIterator = m_rxSpectrumModelInfoMap.begin();
+    for (auto rxInfoIterator = m_rxSpectrumModelInfoMap.begin();
          rxInfoIterator != m_rxSpectrumModelInfoMap.end();
          ++rxInfoIterator)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/multi-model-spectrum-channel.h ns-3.40/src/spectrum/model/multi-model-spectrum-channel.h
--- ns-3.39/src/spectrum/model/multi-model-spectrum-channel.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/multi-model-spectrum-channel.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,11 +20,12 @@
 #ifndef MULTI_MODEL_SPECTRUM_CHANNEL_H
 #define MULTI_MODEL_SPECTRUM_CHANNEL_H
 
+#include "spectrum-channel.h"
+#include "spectrum-converter.h"
+#include "spectrum-propagation-loss-model.h"
+#include "spectrum-value.h"
+
 #include <ns3/propagation-delay-model.h>
-#include <ns3/spectrum-channel.h>
-#include <ns3/spectrum-converter.h>
-#include <ns3/spectrum-propagation-loss-model.h>
-#include <ns3/spectrum-value.h>
 
 #include <map>
 #include <set>
@@ -127,7 +128,7 @@
      * This method checks if m_rxSpectrumModelInfoMap contains an entry
      * for the given TX SpectrumModel. If such entry exists, it returns
      * an iterator pointing to it. If not, it creates a new entry in
-     * m_txSpectrumMpodelInfoMap, and returns an iterator to it.
+     * m_txSpectrumModelInfoMap, and returns an iterator to it.
      *
      * \param txSpectrumModel The TX SpectrumModel  being considered
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc ns-3.40/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc
--- ns-3.39/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc	2023-09-27 13:30:37.874839800 -0700
@@ -18,7 +18,8 @@
 
 #include "phased-array-spectrum-propagation-loss-model.h"
 
-#include "ns3/spectrum-signal-parameters.h"
+#include "spectrum-signal-parameters.h"
+
 #include <ns3/log.h>
 #include <ns3/phased-array-model.h>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/phased-array-spectrum-propagation-loss-model.h ns-3.40/src/spectrum/model/phased-array-spectrum-propagation-loss-model.h
--- ns-3.39/src/spectrum/model/phased-array-spectrum-propagation-loss-model.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/phased-array-spectrum-propagation-loss-model.h	2023-09-27 13:30:37.874839800 -0700
@@ -19,10 +19,11 @@
 #ifndef PHASED_ARRAY_SPECTRUM_PROPAGATION_LOSS_MODEL_H
 #define PHASED_ARRAY_SPECTRUM_PROPAGATION_LOSS_MODEL_H
 
+#include "spectrum-value.h"
+
 #include <ns3/mobility-model.h>
 #include <ns3/object.h>
 #include <ns3/phased-array-model.h>
-#include <ns3/spectrum-value.h>
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/single-model-spectrum-channel.cc ns-3.40/src/spectrum/model/single-model-spectrum-channel.cc
--- ns-3.39/src/spectrum/model/single-model-spectrum-channel.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/single-model-spectrum-channel.cc	2023-09-27 13:30:37.874839800 -0700
@@ -19,6 +19,10 @@
 
 #include "single-model-spectrum-channel.h"
 
+#include "spectrum-phy.h"
+#include "spectrum-propagation-loss-model.h"
+#include "spectrum-transmit-filter.h"
+
 #include <ns3/angles.h>
 #include <ns3/antenna-model.h>
 #include <ns3/double.h>
@@ -32,9 +36,6 @@
 #include <ns3/propagation-delay-model.h>
 #include <ns3/propagation-loss-model.h>
 #include <ns3/simulator.h>
-#include <ns3/spectrum-phy.h>
-#include <ns3/spectrum-propagation-loss-model.h>
-#include <ns3/spectrum-transmit-filter.h>
 
 #include <algorithm>
 
@@ -118,9 +119,7 @@
 
     Ptr<MobilityModel> senderMobility = txParams->txPhy->GetMobility();
 
-    for (PhyList::const_iterator rxPhyIterator = m_phyList.begin();
-         rxPhyIterator != m_phyList.end();
-         ++rxPhyIterator)
+    for (auto rxPhyIterator = m_phyList.begin(); rxPhyIterator != m_phyList.end(); ++rxPhyIterator)
     {
         Ptr<NetDevice> rxNetDevice = (*rxPhyIterator)->GetDevice();
         Ptr<NetDevice> txNetDevice = txParams->txPhy->GetDevice();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/single-model-spectrum-channel.h ns-3.40/src/spectrum/model/single-model-spectrum-channel.h
--- ns-3.39/src/spectrum/model/single-model-spectrum-channel.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/single-model-spectrum-channel.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,8 +20,9 @@
 #ifndef SINGLE_MODEL_SPECTRUM_CHANNEL_H
 #define SINGLE_MODEL_SPECTRUM_CHANNEL_H
 
-#include <ns3/spectrum-channel.h>
-#include <ns3/spectrum-model.h>
+#include "spectrum-channel.h"
+#include "spectrum-model.h"
+
 #include <ns3/traced-callback.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-analyzer.h ns-3.40/src/spectrum/model/spectrum-analyzer.h
--- ns-3.39/src/spectrum/model/spectrum-analyzer.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-analyzer.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,13 +20,14 @@
 #ifndef SPECTRUM_ANALYZER_H
 #define SPECTRUM_ANALYZER_H
 
+#include "spectrum-channel.h"
+#include "spectrum-phy.h"
+#include "spectrum-value.h"
+
 #include <ns3/mobility-model.h>
 #include <ns3/net-device.h>
 #include <ns3/nstime.h>
 #include <ns3/packet.h>
-#include <ns3/spectrum-channel.h>
-#include <ns3/spectrum-phy.h>
-#include <ns3/spectrum-value.h>
 
 #include <fstream>
 #include <string>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-channel.h ns-3.40/src/spectrum/model/spectrum-channel.h
--- ns-3.39/src/spectrum/model/spectrum-channel.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-channel.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,17 +20,18 @@
 #ifndef SPECTRUM_CHANNEL_H
 #define SPECTRUM_CHANNEL_H
 
+#include "phased-array-spectrum-propagation-loss-model.h"
+#include "spectrum-phy.h"
+#include "spectrum-propagation-loss-model.h"
+#include "spectrum-signal-parameters.h"
+#include "spectrum-transmit-filter.h"
+
 #include <ns3/channel.h>
 #include <ns3/mobility-model.h>
 #include <ns3/nstime.h>
 #include <ns3/object.h>
-#include <ns3/phased-array-spectrum-propagation-loss-model.h>
 #include <ns3/propagation-delay-model.h>
 #include <ns3/propagation-loss-model.h>
-#include <ns3/spectrum-phy.h>
-#include <ns3/spectrum-propagation-loss-model.h>
-#include <ns3/spectrum-signal-parameters.h>
-#include <ns3/spectrum-transmit-filter.h>
 #include <ns3/traced-callback.h>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-converter.cc ns-3.40/src/spectrum/model/spectrum-converter.cc
--- ns-3.39/src/spectrum/model/spectrum-converter.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-converter.cc	2023-09-27 13:30:37.874839800 -0700
@@ -17,9 +17,10 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
+#include "spectrum-converter.h"
+
 #include <ns3/assert.h>
 #include <ns3/log.h>
-#include <ns3/spectrum-converter.h>
 
 #include <algorithm>
 
@@ -40,13 +41,10 @@
     m_toSpectrumModel = toSpectrumModel;
 
     size_t rowPtr = 0;
-    for (Bands::const_iterator toit = toSpectrumModel->Begin(); toit != toSpectrumModel->End();
-         ++toit)
+    for (auto toit = toSpectrumModel->Begin(); toit != toSpectrumModel->End(); ++toit)
     {
         size_t colInd = 0;
-        for (Bands::const_iterator fromit = fromSpectrumModel->Begin();
-             fromit != fromSpectrumModel->End();
-             ++fromit)
+        for (auto fromit = fromSpectrumModel->Begin(); fromit != fromSpectrumModel->End(); ++fromit)
         {
             double c = GetCoefficient(*fromit, *toit);
             NS_LOG_LOGIC("(" << fromit->fl << "," << fromit->fh << ")"
@@ -82,12 +80,10 @@
 
     Ptr<SpectrumValue> tvvf = Create<SpectrumValue>(m_toSpectrumModel);
 
-    Values::iterator tvit = tvvf->ValuesBegin();
+    auto tvit = tvvf->ValuesBegin();
     size_t i = 0; // Index of conversion coefficient
 
-    for (std::vector<size_t>::const_iterator convIt = m_conversionRowPtr.begin();
-         convIt != m_conversionRowPtr.end();
-         ++convIt)
+    for (auto convIt = m_conversionRowPtr.begin(); convIt != m_conversionRowPtr.end(); ++convIt)
     {
         double sum = 0;
         while (i < *convIt)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-converter.h ns-3.40/src/spectrum/model/spectrum-converter.h
--- ns-3.39/src/spectrum/model/spectrum-converter.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-converter.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,7 +20,7 @@
 #ifndef SPECTRUM_CONVERTER_H
 #define SPECTRUM_CONVERTER_H
 
-#include <ns3/spectrum-value.h>
+#include "spectrum-value.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-error-model.cc ns-3.40/src/spectrum/model/spectrum-error-model.cc
--- ns-3.39/src/spectrum/model/spectrum-error-model.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-error-model.cc	2023-09-27 13:30:37.874839800 -0700
@@ -79,8 +79,8 @@
     SpectrumValue CapacityPerHertz = Log2(1 + sinr);
     double capacity = 0;
 
-    Bands::const_iterator bi = CapacityPerHertz.ConstBandsBegin();
-    Values::const_iterator vi = CapacityPerHertz.ConstValuesBegin();
+    auto bi = CapacityPerHertz.ConstBandsBegin();
+    auto vi = CapacityPerHertz.ConstValuesBegin();
 
     while (bi != CapacityPerHertz.ConstBandsEnd())
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-error-model.h ns-3.40/src/spectrum/model/spectrum-error-model.h
--- ns-3.39/src/spectrum/model/spectrum-error-model.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-error-model.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,11 +20,12 @@
 #ifndef SPECTRUM_ERROR_MODEL_H
 #define SPECTRUM_ERROR_MODEL_H
 
+#include "spectrum-value.h"
+
 #include <ns3/nstime.h>
 #include <ns3/object.h>
 #include <ns3/packet.h>
 #include <ns3/ptr.h>
-#include <ns3/spectrum-value.h>
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-interference.h ns-3.40/src/spectrum/model/spectrum-interference.h
--- ns-3.39/src/spectrum/model/spectrum-interference.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-interference.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,10 +20,11 @@
 #ifndef SPECTRUM_INTERFERENCE_H
 #define SPECTRUM_INTERFERENCE_H
 
+#include "spectrum-value.h"
+
 #include <ns3/nstime.h>
 #include <ns3/object.h>
 #include <ns3/packet.h>
-#include <ns3/spectrum-value.h>
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-model-300kHz-300GHz-log.cc ns-3.40/src/spectrum/model/spectrum-model-300kHz-300GHz-log.cc
--- ns-3.39/src/spectrum/model/spectrum-model-300kHz-300GHz-log.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-model-300kHz-300GHz-log.cc	2023-09-27 13:30:37.874839800 -0700
@@ -17,7 +17,7 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
-#include <ns3/spectrum-model-300kHz-300GHz-log.h>
+#include "spectrum-model-300kHz-300GHz-log.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-model-300kHz-300GHz-log.h ns-3.40/src/spectrum/model/spectrum-model-300kHz-300GHz-log.h
--- ns-3.39/src/spectrum/model/spectrum-model-300kHz-300GHz-log.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-model-300kHz-300GHz-log.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,7 +20,7 @@
 #ifndef FREQS_300KHZ_300GHZ_LOG_H
 #define FREQS_300KHZ_300GHZ_LOG_H
 
-#include <ns3/spectrum-value.h>
+#include "spectrum-value.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-model.cc ns-3.40/src/spectrum/model/spectrum-model.cc
--- ns-3.39/src/spectrum/model/spectrum-model.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-model.cc	2023-09-27 13:30:37.874839800 -0700
@@ -18,9 +18,10 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
+#include "spectrum-model.h"
+
 #include <ns3/assert.h>
 #include <ns3/log.h>
-#include <ns3/spectrum-model.h>
 
 #include <cmath>
 #include <cstddef>
@@ -43,8 +44,7 @@
     NS_ASSERT(centerFreqs.size() > 1);
     m_uid = ++m_uidCount;
 
-    for (std::vector<double>::const_iterator it = centerFreqs.begin(); it != centerFreqs.end();
-         ++it)
+    for (auto it = centerFreqs.begin(); it != centerFreqs.end(); ++it)
     {
         BandInfo e;
         e.fc = *it;
@@ -110,9 +110,9 @@
 bool
 SpectrumModel::IsOrthogonal(const SpectrumModel& other) const
 {
-    for (Bands::const_iterator myIt = Begin(); myIt != End(); ++myIt)
+    for (auto myIt = Begin(); myIt != End(); ++myIt)
     {
-        for (Bands::const_iterator otherIt = other.Begin(); otherIt != other.End(); ++otherIt)
+        for (auto otherIt = other.Begin(); otherIt != other.End(); ++otherIt)
         {
             if (std::max(myIt->fl, otherIt->fl) < std::min(myIt->fh, otherIt->fh))
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-model-ism2400MHz-res1MHz.cc ns-3.40/src/spectrum/model/spectrum-model-ism2400MHz-res1MHz.cc
--- ns-3.39/src/spectrum/model/spectrum-model-ism2400MHz-res1MHz.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-model-ism2400MHz-res1MHz.cc	2023-09-27 13:30:37.874839800 -0700
@@ -17,7 +17,7 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
-#include <ns3/spectrum-model-ism2400MHz-res1MHz.h>
+#include "spectrum-model-ism2400MHz-res1MHz.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-model-ism2400MHz-res1MHz.h ns-3.40/src/spectrum/model/spectrum-model-ism2400MHz-res1MHz.h
--- ns-3.39/src/spectrum/model/spectrum-model-ism2400MHz-res1MHz.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-model-ism2400MHz-res1MHz.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,7 +20,7 @@
 #ifndef FREQS_ISM2400MHZ_RES1MHZ_H
 #define FREQS_ISM2400MHZ_RES1MHZ_H
 
-#include <ns3/spectrum-value.h>
+#include "spectrum-value.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-phy.cc ns-3.40/src/spectrum/model/spectrum-phy.cc
--- ns-3.39/src/spectrum/model/spectrum-phy.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-phy.cc	2023-09-27 13:30:37.874839800 -0700
@@ -19,11 +19,12 @@
 
 #include "spectrum-phy.h"
 
+#include "spectrum-channel.h"
+#include "spectrum-value.h"
+
 #include <ns3/log.h>
 #include <ns3/mobility-model.h>
 #include <ns3/net-device.h>
-#include <ns3/spectrum-channel.h>
-#include <ns3/spectrum-value.h>
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-propagation-loss-model.h ns-3.40/src/spectrum/model/spectrum-propagation-loss-model.h
--- ns-3.39/src/spectrum/model/spectrum-propagation-loss-model.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-propagation-loss-model.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,9 +20,10 @@
 #ifndef SPECTRUM_PROPAGATION_LOSS_MODEL_H
 #define SPECTRUM_PROPAGATION_LOSS_MODEL_H
 
+#include "spectrum-value.h"
+
 #include <ns3/mobility-model.h>
 #include <ns3/object.h>
-#include <ns3/spectrum-value.h>
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-signal-parameters.cc ns-3.40/src/spectrum/model/spectrum-signal-parameters.cc
--- ns-3.39/src/spectrum/model/spectrum-signal-parameters.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-signal-parameters.cc	2023-09-27 13:30:37.874839800 -0700
@@ -17,11 +17,13 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
+#include "spectrum-signal-parameters.h"
+
+#include "spectrum-phy.h"
+#include "spectrum-value.h"
+
 #include <ns3/antenna-model.h>
 #include <ns3/log.h>
-#include <ns3/spectrum-phy.h>
-#include <ns3/spectrum-signal-parameters.h>
-#include <ns3/spectrum-value.h>
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-value.cc ns-3.40/src/spectrum/model/spectrum-value.cc
--- ns-3.39/src/spectrum/model/spectrum-value.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-value.cc	2023-09-27 13:30:37.874839800 -0700
@@ -18,9 +18,10 @@
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
 
+#include "spectrum-value.h"
+
 #include <ns3/log.h>
 #include <ns3/math.h>
-#include <ns3/spectrum-value.h>
 
 namespace ns3
 {
@@ -100,8 +101,8 @@
 void
 SpectrumValue::Add(const SpectrumValue& x)
 {
-    Values::iterator it1 = m_values.begin();
-    Values::const_iterator it2 = x.m_values.begin();
+    auto it1 = m_values.begin();
+    auto it2 = x.m_values.begin();
 
     NS_ASSERT(m_spectrumModel == x.m_spectrumModel);
     NS_ASSERT(m_values.size() == x.m_values.size());
@@ -117,7 +118,7 @@
 void
 SpectrumValue::Add(double s)
 {
-    Values::iterator it1 = m_values.begin();
+    auto it1 = m_values.begin();
 
     while (it1 != m_values.end())
     {
@@ -129,8 +130,8 @@
 void
 SpectrumValue::Subtract(const SpectrumValue& x)
 {
-    Values::iterator it1 = m_values.begin();
-    Values::const_iterator it2 = x.m_values.begin();
+    auto it1 = m_values.begin();
+    auto it2 = x.m_values.begin();
 
     NS_ASSERT(m_spectrumModel == x.m_spectrumModel);
     NS_ASSERT(m_values.size() == x.m_values.size());
@@ -152,8 +153,8 @@
 void
 SpectrumValue::Multiply(const SpectrumValue& x)
 {
-    Values::iterator it1 = m_values.begin();
-    Values::const_iterator it2 = x.m_values.begin();
+    auto it1 = m_values.begin();
+    auto it2 = x.m_values.begin();
 
     NS_ASSERT(m_spectrumModel == x.m_spectrumModel);
     NS_ASSERT(m_values.size() == x.m_values.size());
@@ -169,7 +170,7 @@
 void
 SpectrumValue::Multiply(double s)
 {
-    Values::iterator it1 = m_values.begin();
+    auto it1 = m_values.begin();
 
     while (it1 != m_values.end())
     {
@@ -181,8 +182,8 @@
 void
 SpectrumValue::Divide(const SpectrumValue& x)
 {
-    Values::iterator it1 = m_values.begin();
-    Values::const_iterator it2 = x.m_values.begin();
+    auto it1 = m_values.begin();
+    auto it2 = x.m_values.begin();
 
     NS_ASSERT(m_spectrumModel == x.m_spectrumModel);
     NS_ASSERT(m_values.size() == x.m_values.size());
@@ -199,7 +200,7 @@
 SpectrumValue::Divide(double s)
 {
     NS_LOG_FUNCTION(this << s);
-    Values::iterator it1 = m_values.begin();
+    auto it1 = m_values.begin();
 
     while (it1 != m_values.end())
     {
@@ -211,7 +212,7 @@
 void
 SpectrumValue::ChangeSign()
 {
-    Values::iterator it1 = m_values.begin();
+    auto it1 = m_values.begin();
 
     while (it1 != m_values.end())
     {
@@ -256,7 +257,7 @@
 SpectrumValue::Pow(double exp)
 {
     NS_LOG_FUNCTION(this << exp);
-    Values::iterator it1 = m_values.begin();
+    auto it1 = m_values.begin();
 
     while (it1 != m_values.end())
     {
@@ -269,7 +270,7 @@
 SpectrumValue::Exp(double base)
 {
     NS_LOG_FUNCTION(this << base);
-    Values::iterator it1 = m_values.begin();
+    auto it1 = m_values.begin();
 
     while (it1 != m_values.end())
     {
@@ -282,7 +283,7 @@
 SpectrumValue::Log10()
 {
     NS_LOG_FUNCTION(this);
-    Values::iterator it1 = m_values.begin();
+    auto it1 = m_values.begin();
 
     while (it1 != m_values.end())
     {
@@ -295,7 +296,7 @@
 SpectrumValue::Log2()
 {
     NS_LOG_FUNCTION(this);
-    Values::iterator it1 = m_values.begin();
+    auto it1 = m_values.begin();
 
     while (it1 != m_values.end())
     {
@@ -308,7 +309,7 @@
 SpectrumValue::Log()
 {
     NS_LOG_FUNCTION(this);
-    Values::iterator it1 = m_values.begin();
+    auto it1 = m_values.begin();
 
     while (it1 != m_values.end())
     {
@@ -321,7 +322,7 @@
 Norm(const SpectrumValue& x)
 {
     double s = 0;
-    Values::const_iterator it1 = x.ConstValuesBegin();
+    auto it1 = x.ConstValuesBegin();
     while (it1 != x.ConstValuesEnd())
     {
         s += (*it1) * (*it1);
@@ -334,7 +335,7 @@
 Sum(const SpectrumValue& x)
 {
     double s = 0;
-    Values::const_iterator it1 = x.ConstValuesBegin();
+    auto it1 = x.ConstValuesBegin();
     while (it1 != x.ConstValuesEnd())
     {
         s += (*it1);
@@ -347,7 +348,7 @@
 Prod(const SpectrumValue& x)
 {
     double s = 0;
-    Values::const_iterator it1 = x.ConstValuesBegin();
+    auto it1 = x.ConstValuesBegin();
     while (it1 != x.ConstValuesEnd())
     {
         s *= (*it1);
@@ -360,8 +361,8 @@
 Integral(const SpectrumValue& arg)
 {
     double i = 0;
-    Values::const_iterator vit = arg.ConstValuesBegin();
-    Bands::const_iterator bit = arg.ConstBandsBegin();
+    auto vit = arg.ConstValuesBegin();
+    auto bit = arg.ConstBandsBegin();
     while (vit != arg.ConstValuesEnd())
     {
         NS_ASSERT(bit != arg.ConstBandsEnd());
@@ -392,7 +393,7 @@
 std::ostream&
 operator<<(std::ostream& os, const SpectrumValue& pvf)
 {
-    Values::const_iterator it1 = pvf.ConstValuesBegin();
+    auto it1 = pvf.ConstValuesBegin();
     while (it1 != pvf.ConstValuesEnd())
     {
         os << *it1 << " ";
@@ -612,7 +613,7 @@
 SpectrumValue&
 SpectrumValue::operator=(double rhs)
 {
-    Values::iterator it1 = m_values.begin();
+    auto it1 = m_values.begin();
 
     while (it1 != m_values.end())
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/spectrum-value.h ns-3.40/src/spectrum/model/spectrum-value.h
--- ns-3.39/src/spectrum/model/spectrum-value.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/spectrum-value.h	2023-09-27 13:30:37.874839800 -0700
@@ -20,9 +20,10 @@
 #ifndef SPECTRUM_VALUE_H
 #define SPECTRUM_VALUE_H
 
+#include "spectrum-model.h"
+
 #include <ns3/ptr.h>
 #include <ns3/simple-ref-count.h>
-#include <ns3/spectrum-model.h>
 
 #include <ostream>
 #include <vector>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/three-gpp-channel-model.cc ns-3.40/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.39/src/spectrum/model/three-gpp-channel-model.cc	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/three-gpp-channel-model.cc	2023-09-27 13:30:37.874839800 -0700
@@ -2197,12 +2197,11 @@
 {
     NS_LOG_FUNCTION(this);
 
-    DoubleVector powerAttenuation;
-    uint8_t clusterNum = clusterAOA.size();
-    for (uint8_t cInd = 0; cInd < clusterNum; cInd++)
-    {
-        powerAttenuation.push_back(0); // Initial power attenuation for all clusters to be 0 dB;
-    }
+    auto clusterNum = clusterAOA.size();
+
+    // Initial power attenuation for all clusters to be 0 dB
+    DoubleVector powerAttenuation(clusterNum, 0);
+
     // step a: the number of non-self blocking blockers is stored in m_numNonSelfBlocking.
 
     // step b:Generate the size and location of each blocker
@@ -2315,7 +2314,7 @@
     }
 
     // step c: Determine the attenuation of each blocker due to blockers
-    for (uint8_t cInd = 0; cInd < clusterNum; cInd++)
+    for (std::size_t cInd = 0; cInd < clusterNum; cInd++)
     {
         NS_ASSERT_MSG(clusterAOA[cInd] >= 0 && clusterAOA[cInd] <= 360,
                       "the AOA should be the range of [0,360]");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/three-gpp-channel-model.h ns-3.40/src/spectrum/model/three-gpp-channel-model.h
--- ns-3.39/src/spectrum/model/three-gpp-channel-model.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/three-gpp-channel-model.h	2023-09-27 13:30:37.874839800 -0700
@@ -21,10 +21,11 @@
 #ifndef THREE_GPP_CHANNEL_H
 #define THREE_GPP_CHANNEL_H
 
+#include "matrix-based-channel-model.h"
+
 #include "ns3/angles.h"
 #include <ns3/boolean.h>
 #include <ns3/channel-condition-model.h>
-#include <ns3/matrix-based-channel-model.h>
 
 #include <complex.h>
 #include <unordered_map>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h ns-3.40/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h
--- ns-3.39/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2023-07-05 14:23:48.081428300 -0700
+++ ns-3.40/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2023-09-27 13:30:37.874839800 -0700
@@ -21,8 +21,9 @@
 #ifndef THREE_GPP_SPECTRUM_PROPAGATION_LOSS_H
 #define THREE_GPP_SPECTRUM_PROPAGATION_LOSS_H
 
-#include "ns3/matrix-based-channel-model.h"
-#include "ns3/phased-array-spectrum-propagation-loss-model.h"
+#include "matrix-based-channel-model.h"
+#include "phased-array-spectrum-propagation-loss-model.h"
+
 #include "ns3/random-variable-stream.h"
 
 #include <complex.h>
